** Constructing Ethnic Group Measures at the Location Level 

		use "EthnicityRegister\Registers06_LocData_CollapsedLoc62.dta", clear 
		
	*1. Creating Loc-Level Summary Stats by Converting to Long 
		reshape long p_regist_,  i(loc_id_cbm) j(grpcode62)	
			** Calculating  ELF  
				gen s2 =   p_regist_*  p_regist_
				egen ss2 = sum(s2), by(loc_id_cbm)
				gen elf_reg = 1-ss2
				drop s2 ss2 
			** Calculating Reynal Querol 
				gen bob = ((((0.5-p_regist_)/0.5)^2)*p_regist_)
				egen bob1 = sum(bob), by(loc_id_cbm)
				gen rq_reg = 1-bob1 
				drop bob bob1
			** Calculating  Effective Number of Groups  	
				gen s2 =   p_regist_*  p_regist_
				egen ss2 = sum(s2), by(loc_id_cbm)	
				gen en_group_reg = 1/ss2 
				drop s2 ss2 
				collapse (first)  elf_reg rq_reg en_group_reg, by(loc_id_cbm) 
				sort loc_id_cbm 
		save "EthnicityRegister\Registers06_LocData_CollapsedLoc_GroupSumStats62.dta", replace
	* 2.  Merging Loc-Level Summary Stats with Collapsed Loc Data  
		use "EthnicityRegister\Registers06_LocData_CollapsedLoc62.dta", clear
		merge loc_id_cbm using "EthnicityRegister\Registers06_LocData_CollapsedLoc_GroupSumStats62.dta"
		drop _merge
				** Rename and Relabel 
				label variable  p_notmatched "Proportion of Unmatched Names in Location"
				label variable  elf_reg "ELF from Register"
				label variable rq_reg "Reyna-Querol Index from Register"
				label variable  en_group_reg "Effective Number of Groups from Register" 
	
		
	*3.  Renaming and labeling 
	
			label var  p_regist_9 "Prop. Embu"
			label var  p_regist_16 "Prop. Teso"
			label var  p_regist_17 "Prop. Kalenjin"
			label var  p_regist_18 "Prop. Kamba"
			label var  p_regist_19 "Prop. Kikuyu"
			label var  p_regist_21 "Prop. Kisii"
			label var  p_regist_22 "Prop. Kuria"
			label var  p_regist_23 "Prop. Luhya"
			label var  p_regist_24 "Prop. Luo"
			label var  p_regist_26 "Prop. Maasai"
			label var  p_regist_27 "Prop. Mbeere"
			label var  p_regist_28 "Prop. Meru"
			label var  p_regist_29 "Prop. Mijikenda"
			label var  p_regist_35 "Prop. Orma"
			label var  p_regist_39 "Prop. Pokomo"
			label var  p_regist_50 "Prop. Taita"
			label var  p_regist_47 "Prop. Somali"
			label var  p_regist_53 "Prop. Tharaka"

			gen reg_kalenjin =  p_regist_17
			gen reg_kikuyu =  p_regist_19
			gen reg_kisii =  p_regist_21
			gen reg_luhya =  p_regist_23
			gen reg_luo =  p_regist_24
			gen reg_maasai =  p_regist_26
 
		
		

			label var  reg_kalenjin "Prop. Kalenjin"
			label var  reg_kikuyu "Prop. Kikuyu"
			label var  reg_kisii "Prop. Kisii"
			label var  reg_luhya "Prop. Luhya"
			label var  reg_luo "Prop. Luo"
			label var  reg_maasai "Prop. Maasai"
	 
		sort   loc_id_cbm
			
		save "EthnicityRegister\EthnicGroupsByGroupLoc.dta", replace 
				


