** Ethnicity Measures Relying on Data by Polling Station 	
* ssc install seg 
  
		local group62b 9 16 17 18 19 21 22 23 24 26 27 28 29 35 39  50 53
		local part_province  prov_nairobi prov_coast  prov_eastern prov_central prov_riftvalley prov_western prov_nyanza

		
* 1. Constructing Segregation Measures by Location  
		use "EthnicityRegister\prov_coast_Base_SegIndex.dta" , clear
		keep if psid==""

		foreach i of local part_province {
		append using "EthnicityRegister/`i'_Base_SegIndex.dta"
		}

				rename n_group_999 n_notmatched 
				egen ps_total_coded = rowtotal(n_group_*)
				foreach c of local group62b {
					gen  p_regist_`c' = n_group_`c'/ps_total_coded 
				}
				
				
	seg n_group_9 n_group_16 n_group_17 n_group_18 n_group_19 n_group_21 n_group_22 n_group_23 n_group_24 n_group_26 n_group_27 n_group_28 n_group_29  n_group_35 n_group_39   n_group_50 n_group_53, h by(loc_id_cbm) unit(psid3) generate(h HSeg e Entropy)
	gen MSeg =  HSeg *Entropy
	seg n_group_9 n_group_16 n_group_17 n_group_18 n_group_19 n_group_21 n_group_22 n_group_23 n_group_24 n_group_26 n_group_27 n_group_28 n_group_29 n_group_35 n_group_39   n_group_50 n_group_53 n_notmatched, h by(loc_id_cbm) unit(psid3) generate(h HSeg2 e Entropy2)
	gen MSeg2 =  HSeg2 *Entropy2

	 
	rename psid1 constcode 
	destring constcode, replace 



	seg n_group_9 n_group_16 n_group_17 n_group_18 n_group_19 n_group_21 n_group_22 n_group_23 n_group_24 n_group_26 n_group_27 n_group_28 n_group_29  n_group_35 n_group_39   n_group_50 n_group_53, h by(constcode) unit(psid3) generate(h HSeg_Const e Entropy_Const)
	seg n_group_9 n_group_16 n_group_17 n_group_18 n_group_19 n_group_21 n_group_22 n_group_23 n_group_24 n_group_26 n_group_27 n_group_28 n_group_29 n_group_35 n_group_39   n_group_50 n_group_53 n_notmatched, h by(constcode) unit(psid3) generate(h HSeg2_Const e Entropy2_Const)
 
*2. Creating a location-level dataset of segregation measures 
		preserve 

			collapse (mean)  prop_codedvoters  MSeg HSeg Entropy MSeg2 HSeg2 Entropy2   HSeg2_Const HSeg_Const , by(loc_id_cbm)
			label var HSeg2 "Information Index - Counting Unmatched" 
			label var HSeg "Information Index" 
			label var HSeg_Const "Information Index Constituency" 
			label var HSeg2_Const "Information Index Constituency - Counting Unmatched" 

			save "EthnicityRegister\SegIndex.dta", replace 
 

	restore 

*3. Creating a location-level dataset of segregation measures by group 
egen no_ps_by_loc =  count(psid3), by(loc_id_cbm)
drop if no_ps == 1
		foreach c of local group62b {
			gen n_group_not`c' =  psid_totalvoters- n_group_`c'
			seg n_group_`c' n_group_not`c', d  by(loc_id_cbm) unit(psid3) generate(d diss_`c')
			
		}
collapse (mean) diss_*, by(loc_id_cbm)
reshape long diss_, i(loc_id_cbm) j(grpcode62)
replace diss = . if diss ==0 

save "EthnicityRegister\DissimilarityByGroup.dta", replace
 
	** Splitting and Appending 
			use "EthnicityRegister\DissimilarityByGroup.dta", clear 
			keep if  grpcode62 == 19
			rename diss_ diss_Kikuyu
			drop  grpcode62
			sort loc_id_cbm 
			save "EthnicityRegister\Diss_Kikuyu.dta", replace 

			use "EthnicityRegister\DissimilarityByGroup.dta", clear 
			keep if  grpcode62 == 17
			rename diss_ diss_Kalenjin
			drop  grpcode62
			sort loc_id_cbm 
			save "EthnicityRegister\Diss_Kalenjin.dta", replace 

			use "EthnicityRegister\DissimilarityByGroup.dta", clear 
			keep if  grpcode62 == 26
			rename diss_ diss_Maasai
			drop  grpcode62
			sort loc_id_cbm 
			save "EthnicityRegister\Diss_Maasai.dta", replace 

			use "EthnicityRegister\DissimilarityByGroup.dta", clear 
			keep if  grpcode62 == 23
			rename diss_ diss_Luhya
			drop  grpcode62
			sort loc_id_cbm 
			save "EthnicityRegister\Diss_Luhya.dta", replace 

			use "EthnicityRegister\DissimilarityByGroup.dta", clear 
			keep if  grpcode62 == 21
			rename diss_ diss_Kisii
			drop  grpcode62
			sort loc_id_cbm 
			save "EthnicityRegister\Diss_Kisii.dta", replace 
			
* 4. Ethnic Segregation by Constituency 

  
		use "EthnicityRegister\prov_coast_Base_SegIndex.dta" , clear
		keep if psid==""

		foreach i of local part_province {
		append using "EthnicityRegister/`i'_Base_SegIndex.dta"
		}

				

		collapse (sum) n_group_*, by(psid1)
		drop n_group_999 
		destring psid1, generate(constcode) 
		reshape long n_group_, i(constcode) j(ethcode62)
		egen total = sum(n_group_),by(constcode)

		** ELF 
		gen prop = n_group_/total 
		gen prop2 = prop*prop 
		egen ss2 = sum(prop2), by(constcode)
		gen elf_const = 1 - ss2 
		drop ss2 prop2 
		** RQ 
		gen s3 = (0.5-prop)/(0.5)
		gen s4 = s3*s3*prop
		egen ss4 = sum(s4), by(constcode)
		gen rq_const = 1-ss4 
		keep n_group_ constcode ethcode62 elf_const rq_const psid1
		reshape wide n_group_, i(constcode) j(ethcode62)
		keep psid1 constcode rq_const elf_const 
		keep constcode elf_const rq_const
		save "EthnicityRegister\EthnicConst.dta", replace



