** Matching Names in the 2006 Voter Register to Areas where Ethnic Group X has a supermajority in 1962 

 
	** The whole country   
		local group62 9 16 17 18 19 21 22 23 24 26 27 28 29  35 39 47 50 53
		local prov_registers prov_nairobi prov_coast prov_northeastern prov_eastern prov_central prov_riftvalley prov_western prov_nyanza	
	
	** Provinces other than Northeastern 
		local group62b 9 16 17 18 19 21 22 23 24 26 27 28 29 35 39  50 53
		local part_province  prov_nairobi prov_coast  prov_eastern prov_central prov_riftvalley prov_western prov_nyanza


** 1. A list of 1962 locations containing the name of the group that has a supermajority of over 90%. 

	use "EthnicityRegister\C62Locs_ForMatch.dta", replace
 	 sort loc62_id
	save "EthnicityRegister\C62Locs_ForMatch.dta", replace

	
	 

** 2. To identify contemporary polling stations in which one ethnic group had a supermajority in 1962, merges pollingstation-1962location matches with the 1962 loccation of contemporary polling stations (PS_LocMatces62)


 		use  "EthnicityRegister\PS_LocMatches62.dta", clear 
		sort loc62_id 
		merge loc62_id  using "EthnicityRegister\C62Locs_ForMatch.dta"
		table _merge 
		keep if _merge == 3 
		drop _merge
			** An addition 
			 drop if psid_rc06 == " " 
		sort psid_rc06
		save "EthnicityRegister\PS_GroupMatches62.dta", replace
		
		
** 3. Sorting a dataset of names from the original register. The raw names in the register were cleaned using  a perl script to identify when  the same named differed by punctuation and length.  

		use "EthnicityRegister\Register06_name1_cleaned.dta", clear
		sort name1
		save "EthnicityRegister\Register06_name1_cleaned.dta", replace
		
		
** 4. Calculating the proportion of registered voters with each name falling into an ethnic groups' 1962 supermajority area 

	** 4a. Attaching the cleaned names in the register to a dataset (Register06_name1_cleaned.dta) identifying which group has a 1962 supermajority at that polling station in 1962 (PS_GroupMatches.dta)

				foreach i of local prov_registers {
					use "EthnicityRegister\Register2006/`i'.dta", clear
					egen psid_rc06 = concat(constcode psno), punct(-)
					keep name1 psid_rc06
					sort psid_rc06 
					merge m:1 psid_rc06 using "EthnicityRegister\PS_GroupMatches62.dta"
					keep if _merge == 3 
					drop _merge 

					sort name1 
					merge m:1 name1 using "EthnicityRegister\Register06_name1_cleaned.dta"
					keep if _merge == 3 
					drop if name1_new == "" 
					gen bob = 1 
					collapse (sum) bob, by(name1_new  max_grpno) 
					drop if max_grpno ==.
					rename bob  n_name1_group  
					save "EthnicityRegister/`i'_grouptot_byname_temp62.dta", replace 
					}


	** 4b. Creating a dataset of the number of registered voters with a particular cleaned name in a particular ethnic group's 1962  supermajority area
			use "EthnicityRegister\prov_central_grouptot_byname_temp62.dta", clear
				drop if name1_new ~=" "
			foreach i of local prov_registers{
			append using "EthnicityRegister/`i'_grouptot_byname_temp62.dta"
			}
			collapse (sum)  n_name1_group, by( name1_new max_grpno)		
			save "EthnicityRegister\name_group_tot62.dta", replace 
			reshape wide n_name1_group, i(name1_new) j( max_grpno )
			save "EthnicityRegister\name_group_tot_wide62.dta", replace  

	** 4c. Calculating how many people with each cleaned name are in the voter register 
			use "EthnicityRegister\Register06_name1_cleaned.dta", clear
			collapse (sum) freq, by(name1_new)
			sort name1_new 
			merge 1:1 name1_new using "EthnicityRegister\name_group_tot_wide62.dta"
			table _merge
			keep if _merge == 3 
			drop _merge  
	** 4d. Creating a dataset of all people with a particular  name (freq) are in a location where group c had a supermajority in 1962 (n_name1_group_c)
			foreach c of local group62 {
			gen p_grp`c' = (1/freq)* n_name1_group`c' 
			}
			drop n_name1* freq
			save "EthnicityRegister\name_group_pc_wide62.dta", replace 
			foreach c of local group62 {
			replace p_grp`c' = 0 if p_grp`c' ==. 
			}
			egen max_grp_p = rowmax(p_grp*)
			save "EthnicityRegister\name_group_pc_wide62.dta", replace 
			** The long version is useful for display 
			reshape long p_grp, i(name1_new) j(grpcode62)
			save "EthnicityRegister\name_group_pc_long62.dta", replace 
	
	** 4e Attaching Ethnic Group Labels 
	
		gen group62 = "" 
			replace group62 = "Embu" if grpcode == 9
			replace group62 = "Teso" if grpcode == 16
			replace group62 = "Kalenjin" if grpcode == 17
			replace group62 = "Kamba" if grpcode == 18
			replace group62 = "Kikuyu" if grpcode == 19
			replace group62 = "Kisii" if grpcode == 21
			replace group62 = "Kuria" if grpcode == 22
			replace group62 = "Luhya" if grpcode == 23
			replace group62 = "Luo" if grpcode == 24
			replace group62 = "Maasai" if grpcode == 26
			replace group62 = "Mbere" if grpcode == 27
			replace group62 = "Meru" if grpcode == 28
			replace group62 = "Mijikenda" if grpcode == 29
			replace group62 = "Nderobo" if grpcode == 31
			replace group62 = "Orma" if grpcode == 35
			replace group62 = "Pokomo" if grpcode == 39
			replace group62 = "Taita" if grpcode == 50
			replace group62 = "Tharaka" if grpcode == 53
			replace group62 = "Somali" if grpcode == 47


			save "EthnicityRegister\name_group_pc_long62.dta", replace

			
		
** 5. Rules Matching Names to Groups 
		compress 
		egen bob  = rank( p_grp), by(name1_new) unique
		egen rank = rank(bob), by(name1_new) field
		drop bob
		gen bob = p_grp if rank == 1
		egen p1st = max(bob), by(name1_new)
		drop bob 
		gen bob = p_grp if rank == 2
		egen p2nd= max(bob), by(name1_new)
		drop bob 
		gen firstsec = p1st/p2nd 
		gen match = ""
	
		*Accept matches where p1st is greater than 1/3  
		replace  match = name1_new if rank == 1 &   p1st >.33
		
		** Accept matches if the first is three or more times likely than the second 
		replace  match = name1_new if rank == 1 &  firstsec > 3		
	


		drop if match == ""
		sort name1_new 
		
 
		 
		sort name1_new 
		save "EthnicityRegister\name_grpmatches62.dta", replace	
 
** 6. Erasing Intemediary Files 

 
erase "EthnicityRegister\name_group_tot62.dta"
erase "EthnicityRegister\name_group_tot_wide62.dta"
erase "EthnicityRegister\name_group_pc_wide62.dta"
erase "EthnicityRegister\name_group_pc_long62.dta"
	foreach i of local prov_registers{
	erase  "EthnicityRegister/`i'_grouptot_byname_temp62.dta"
	}
 




 
