** Attaching Ethnic Group Matches to Names in the Original Data and Calculating Ethnic Group Shares by Polling Station and Location 

			local prov_registers prov_nairobi prov_coast prov_northeastern prov_eastern prov_central prov_riftvalley prov_western prov_nyanza
			local group62 9 16 17 18 19 21 22 23 24 26 27 28 29  35 39  47 50 53
			
			** For all Provinces but Northeastern 
local group62b 9 16 17 18 19 21 22 23 24 26 27 28 29 35 39   50 53
local part_province  prov_nairobi prov_coast  prov_eastern prov_central prov_riftvalley prov_western prov_nyanza


* 1. Polling Station Matches to Contemporary Locations 
 
	use "EthnicityRegister\PS_Loc_Matches_RC06.dta", replace 
	sort psid 
	save "EthnicityRegister\PS_Loc_Matches_RC06.dta", replace 


*2. Sorting the cleaned version of all names in the register 
	
		use "EthnicityRegister\Register06_name1_cleaned.dta", clear
		sort name1
		save "EthnicityRegister\Register06_name1_cleaned.dta", replace
	

		
* 3 Attaching cleaned names to preexisting register   

			foreach i of local prov_registers{
			use "EthnicityRegister/Register2006/`i'.dta", clear 
			keep  name1 constcode psno
			sort name1
			merge m:1 name1 using "EthnicityRegister/Register06_name1_cleaned.dta"
			drop if _merge == 2 
			drop _merge 
			egen psid = concat( constcode psno), punct(-)
			keep  name1_new name1_id_new freq_new psid
			save "EthnicityRegister/`i'_cleaned.dta", replace 
			clear 
			}
			
			
 * 4.  Attaching ethnic group matches to a version of the register that has cleaned names 
			 foreach i of local prov_registers{
				 use "EthnicityRegister/`i'_cleaned.dta", clear
				 sort name1_new
				  merge m:1 name1_new using "EthnicityRegister\name_grpmatches62.dta"
				  drop if _merge == 2 
				  drop _merge 
				  save "EthnicityRegister/`i'_EIMatches.dta", replace
			  }			
 		
* 5.  Calculating Location Level Shares by Ethnic Group  Using Register Name-Matches 


		foreach i of local prov_registers {
			use "EthnicityRegister/`i'_EIMatches.dta"
			gen bob = 1 
			split psid, parse(-) 
			egen regconst = sum(bob), by(psid1)
			drop  psid2  
			rename psid1 constcode 
			sort psid 
			merge m:1 psid using "EthnicityRegister\PS_Loc_Matches_RC06.dta"
			keep if _merge ==3
			drop _merge
			egen estregconst = total(bob), by(const)
			egen estregloc = total(bob), by(loc) 
			replace  grpcode62 = 999 if  grpcode62 ==. 
			replace group62 = "NOTMATCHED"  if group62 == "" 
			foreach c of local group62 {
			egen n_group_`c' = total(bob) if grpcode62 == `c', by(loc_id_cbm) 
			}
			egen n_group_999 = total(bob) if grpcode62 == 999 
			collapse (mean)  regconst estregconst estregloc n_group_* , by(loc_id_cbm)
			save "EthnicityRegister/`i'_LocData.dta", replace 
		}

*6  Appending province-level  location datasets datasets 
		clear
		use "EthnicityRegister\prov_northeastern_LocData.dta", clear 
		drop if loc_id_cbm~=.
		foreach i of local prov_registers { 
			append using "EthnicityRegister/`i'_LocData.dta" 
		}
		
 		
		collapse (mean)  regconst estregconst (sum)  estregloc n_group_*, by( loc_id_cbm)

		
		save "EthnicityRegister\Registers06_LocData_CollapsedLoc62.dta", replace
		


		rename n_group_999 n_notmatched
		egen estregloc_coded = rowtotal(n_group_*)  
		foreach c of local group62 {
			gen  p_regist_`c' = n_group_`c'/estregloc_coded
		}
		gen propestconst =  estregconst/ regconst
		gen p_notmatched = n_notmatched/estregloc
		label variable  regconst "Number of Registered Voters in Constituency"
		label variable    estregconst  "Number of Registered Voters in Constituency from Round1 PS"
		label variable     estregloc "Number of Registered Voters in Location from Round1 PS"
		label variable propestconst "Proportion of Registered Voters Sampled by Constituency" 
		label variable p_notmatched "Proportion of Unmatched Names in Location" 
		sort  loc_id_cbm
		save "EthnicityRegister\Registers06_LocData_CollapsedLoc62.dta", replace



* 7. Creating polling station level ethnicity data (prov_XBase_SegIndex.dta  by province)

			
		foreach i of local part_province { 
		use "EthnicityRegister/`i'_EIMatches.dta", clear
					gen bob = 1 
					split psid, parse(-) 
					egen regconst = sum(bob), by(psid1)
					drop  psid2  
					rename psid1 constcode 
					sort psid 
					merge m:1 psid using "EthnicityRegister\PS_Loc_Matches_RC06.dta"
					keep if _merge ==3
					drop _merge
					egen estregconst = total(bob), by(const)
					egen estregloc = total(bob), by(loc) 
					replace grpcode62 = 999 if grpcode62 ==. 
					replace group62 = "NOTMATCHED"  if group62 == "" 
					foreach c of local group62 {
					egen n_group_`c' = total(bob) if grpcode62 == `c', by(psid) 
					}
					egen n_group_999= total(bob) if group62 == "NOTMATCHED", by(psid) 
					collapse  (mean)  regconst estregconst estregloc loc_id_cbm n_group_*, by(psid)
					
		egen psid_totalvoters  = rowtotal(n_group_*)
		gen psid_codedvoters =  psid_totalvoters -  n_group_999
		gen prop_codedvoters =  psid_codedvoters / psid_totalvoters
		save "EthnicityRegister/`i'.dta", replace
				foreach c of local group62 {
					replace n_group_`c' = 0 if  n_group_`c' == .
				}

		split  psid, parse(-)
		egen psid3 = concat(psid1 psid2)
		destring psid3, replace 
		save "EthnicityRegister/`i'_Base_SegIndex.dta" , replace

		}


 